/*
	(C) 1995-99 AROS - The Amiga Research OS
	$Id: remakedisplay.c,v 1.1.1.1 2005/03/15 15:54:21 laire Exp $
 
	Desc: Intuition function RemakeDisplay()
	Lang: english
*/
#include <proto/graphics.h>
#include "intuition_intern.h"

/*****************************************************************************
 
	NAME */
#include <proto/intuition.h>

AROS_LH0(LONG, RemakeDisplay,

		 /*  SYNOPSIS */

		 /*  LOCATION */
		 struct IntuitionBase *, IntuitionBase, 64, Intuition)

/*  FUNCTION
 
	INPUTS
	None.
 
	RESULT
	Zero for success, non-zero for failure.
 
	NOTES
 
	EXAMPLE
 
	BUGS
 
	SEE ALSO
	RethinkDisplay(), MakeScreen(), graphics.library/MakeVPort(),
	graphics.library/MrgCop(), graphics.library/LoadView()
 
	INTERNALS
 
	HISTORY
 
*****************************************************************************/
{
	AROS_LIBFUNC_INIT
	AROS_LIBBASE_EXT_DECL(struct IntuitionBase *,IntuitionBase)

#ifndef __MORPHOS__
	struct Screen *screen;
	ULONG ilock = LockIBase(0);
#endif
	LONG failure = 0;

#ifndef __MORPHOS__
	for (screen = IntuitionBase->FirstScreen; screen; screen = screen->NextScreen)
	{
		LONG error = MakeVPort(&IntuitionBase->ViewLord, &screen->ViewPort);
		if (error)
			failure = error;
	}

	UnlockIBase(ilock);
#endif

	if (!failure)
		failure = RethinkDisplay();

	return failure;

	AROS_LIBFUNC_EXIT
} /* RemakeDisplay */
